#Use high release base to avoid epel conflict
%define releasebase 10

# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}

# note, the target is only for taging the rpm name
# it has no effect on installation or the build
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%define targetbase Limulus
%endif
Name:    whatsup
Version: 1.13
Group: %{targetbase}/Applications
Release: %{releasebase}.%{targetbase}
Summary: whatsup node up/down detection utility
License: GPL
Source: whatsup-1.13.tar.gz
BuildRequires: perl(ExtUtils::MakeMaker)

%description
Whatsup is a cluster node up/down detection utility.

# Choose what to support here
%define cerebro 0
%define ganglia 1
%define pingd 1
%define openib 0
%define genders 0
%define hostsfile 1
%define perlextensions 0

%if "1" == "%{cerebro}"
%define _with_cerebro --with-cerebro
%else
%define _with_cerebro  %{nil}
%endif
%if "1" == "%{ganglia}"
%define _with_ganglia --with-ganglia
%else
%define _with_ganglia  %{nil}
%endif
%if "1" == "%{pingd}"
%define _with_pingd --with-pingd
%else
%define _with_pingd  %{nil}
%endif
%if "1" == "%{openib}"
%define _with_openib --with-openib
%else
%define _with_openib  %{nil}
%endif
%if "1" == "%{genders}"
%define _with_genders --with-genders
%else
%define _with_genders  %{nil}
%endif
%if "1" == "%{hostsfile}"
%define _with_hostsfile --with-hostsfile
%else
%define _with_hostsfile  %{nil}
%endif
%if "1" == "%{perlextensions}"
%define _with_perl_extensions --with-perl-extensions
%else
%define _with_perl_extensions %{nil}
%endif

%package backend-ganglia
Summary: whatsup ganglia backend
Group: System Environment/Base
Requires: whatsup
%description backend-ganglia
Ganglia backend module

%package backend-cerebro
Summary: whatsup cerebro backend
Group: System Environment/Base
Requires: whatsup
Requires: cerebro
%description backend-cerebro
Cerebro backend module

%package backend-pingd
Summary: whatsup pingd backend
Group: System Environment/Base
Requires: whatsup
%description backend-pingd
Pingd backend module and daemon

%package backend-openib
Summary: whatsup openib backend
Group: System Environment/Base
Requires: whatsup
%description backend-openib
Openib backend module

%package clusterlist-genders
Summary: whatsup genders clusterlist module
Group: System Environment/Base
Requires: whatsup
Requires: genders >= 1.2
%description clusterlist-genders
Genders clusterlist module

%package clusterlist-hostsfile
Summary: whatsup hostsfile clusterlist module
Group: System Environment/Base
Requires: whatsup
%description clusterlist-hostsfile
Hostsfile clusterlist module

%package options-cerebro-monitor
Summary: whatsup cerebro-monitor options module
Group: System Environment/Base
Requires: whatsup
Requires: cerebro
%description options-cerebro-monitor
Cerebro Monitor options module

%package pingd
Summary: whasup pingd daemon
Group: System Environment/Base
%description pingd
Pingd daemon

%package pingd-clusterlist-genders
Summary: whatsup pingd backend clusterlist genders module
Group: System Environment/Base
Requires: whatsup
Requires: whatsup-pingd
%description pingd-clusterlist-genders
Pingd genders clusterlist module

%package pingd-clusterlist-hostsfile
Summary: whatsup pingd backend clusterlist hostsfile module
Group: System Environment/Base
Requires: whatsup
Requires: whatsup-pingd
%description pingd-clusterlist-hostsfile
Pingd hostsfile clusterlist module

%post pingd
if [ "$1" = 1 ]; then
   if [ -x %{_initrddir}/whatsup-pingd ]; then
      /sbin/chkconfig --add whatsup-pingd
      /sbin/chkconfig whatsup-pingd off
   fi
fi
if [ $1 -ge 1 ]; then
   if [ -x %{_initrddir}/whatsup-pingd ]; then
      if %{_initrddir}/whatsup-pingd status | grep -q running; then
         %{_initrddir}/whatsup-pingd restart
      else
         %{_initrddir}/whatsup-pingd condrestart
      fi
   fi
fi

#%{!?_with_perl_extensions: %{!?_without_perl_extensions: %define _with_perl_extensions --with-perl-extensions}}

%prep
%setup -q

%build
%configure --program-prefix=%{?_program_prefix:%{_program_prefix}} \
           --with-perl-destdir="$RPM_BUILD_ROOT" \
           %{?_with_cerebro} \
           %{?_with_ganglia} \
           %{?_with_pingd} \
           %{?_with_openib} \
           %{?_with_genders} \
           %{?_with_hostsfile} \
           %{?_with_perl_extensions} 
make

%install
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi
DESTDIR="$RPM_BUILD_ROOT" make install

%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog DISCLAIMER DISCLAIMER.UC INSTALL NEWS README README.expat 
%config(noreplace) %{_sysconfdir}/nodeupdown.conf
# It doesn't matter if the user chooses a 32bit or 64bit target.  The
# packaging must work off whatever Perl is installed.
%define _perldir %(perl -e 'use Config; $T=$Config{installsitearch}; $P=$Config{siteprefix}; $T=~/$P\\/(.*)\\/site_perl.*/; print "%{_prefix}/$1\\n"')
%{_bindir}/*
%{_includedir}/*
#%dir %{_libdir}/nodeupdown
#%dir %{_libdir}/whatsup
#%{_libdir}/libnodeupdown.*
%{_libdir}/*
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_mandir}/man5/nodeupdown*
%if "1" == "%{perlextensions}"
#%if %{?_with_perl_extensions:1}%{!?_with_perl_extensions:0}
%{_perldir}/*
%endif

%if "1" == "%{ganglia}"
%files backend-ganglia
%defattr(-,root,root)
%{_libdir}/nodeupdown/*ganglia.*
%endif

%if "1" == "%{cerebro}"
%files backend-cerebro
%defattr(-,root,root)
%{_libdir}/nodeupdown/*cerebro.*
%endif

%if "1" == "%{pingd}"
%files backend-pingd
%defattr(-,root,root)
%{_libdir}/nodeupdown/*pingd.*
%endif

%if "1" == "%{openib}"
%files backend-openib
%defattr(-,root,root)
%{_libdir}/nodeupdown/*openib.*
%endif

%if "1" == "%{genders}"
%files clusterlist-genders
%defattr(-,root,root)
%{_libdir}/nodeupdown/*genders.*
%endif

%if "1" == "%{hostfile}"
%files clusterlist-hostsfile
%defattr(-,root,root)
%{_libdir}/nodeupdown/*hostsfile.*
%endif

%if "1" == "%{cerebro}"
%files options-cerebro-monitor
%defattr(-,root,root)
%{_libdir}/whatsup/*cerebro_monitor.*
%endif

%if "1" == "%{pingd}"
%files pingd
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/rc.d/init.d/whatsup-pingd
%config(noreplace) %{_sysconfdir}/pingd.conf
%{_sbindir}/pingd
%dir %{_libdir}/pingd
%{_mandir}/man5/pingd*
%{_mandir}/man8/*

%if "1" == "%{genders}"
%files pingd-clusterlist-genders
%defattr(-,root,root)
%{_libdir}/pingd/*genders.*
%endif

%if "1" == "%{hostfile}"
%files pingd-clusterlist-hostsfile
%defattr(-,root,root)
%{_libdir}/pingd/*hostsfile.*
%endif

%endif
